# Web::Request
# Copyright(c) 2002 MoonWolf <moonwolf@moonwolf.com>
require 'web/common'
require 'web/cookie'

module Web
  # NGXg
  class Request
    # NG[lێ
    class QueryParam < Common::ParamHash
    end
    
    # tH[̒lێ
    class FormParam < Common::ParamHash
    end
    
    def initialize
      # NGXgID(mod_unique_id΁A̒l)
      @request_id = nil
      
      # ZbVID
      @session_id = nil
      
      # T[o
      @env    = Hash.new
      
      # \bh(GET|POST|HEAD)
      @method = nil

      # NG[
      @query_string = nil
      
      # Host
      @host = nil

      # SCRIPT_NAME
      @script_name = nil
      
      # PATH_INFO
      @path_info = nil
      
      @remote_addr  = nil
      @remote_host  = nil
      @remote_ident = nil
      @remote_user  = nil
      
      # HTTPNGXgwb_ɏĂ
      @header = Common::Header.new

      # HTTPNGXg{fB
      @body   = nil

      # NG[ɂp[^
      @query  = QueryParam.new
      # tH[ɂp[^
      @form   = FormParam.new
      # NbL[
      @cookies = Cookie::Cookies.new
      
    end
    attr_accessor :request_id, :session_id
    attr_accessor :method, :query_string, :host, :path_info, :script_name
    attr_accessor :remote_addr, :remote_host, :remote_ident, :remote_user
    attr_reader :env, :header, :query, :form, :cookies
    
    def cleanup
      @form.each {|key,value|
        value.each {|v|
          if v.respond_to? :cleanup
            v.cleanup
          end
        }
      }
    end
    
    
    # Query/Form
    def has_key?(key)
      @query.has_key?(key) || @form.has_key?(key)
    end
    
    def include?(key)
      has_key?(key)
    end
    
    def key?(key)
      has_key?(key)
    end
    
    def member?(key)
      has_key?(key)
    end
    
    def get(key,index=0)
      return nil unless @query.has_key?(key) || @form.has_key?(key)
      val = @query[key, nil] + @form[key, nil]
      return val[index]
    end
    
    def [](key, index=0)
      if index
        get(key, index)
      else
        @query[key, nil] + @form[key, nil]
      end
    end
    
    #
    def body
      @body
    end

    def body=(text)
      @body = text.to_s
    end
    
  end
end # Web
